commit 60276e18f8b9bbf0bf991a32a87c2b1cd3f67cb1
Author: freddy77 <freddy77>
Date:   Wed Jul 30 08:02:53 2008 +0000

    added needed hmac code for NTLMv2

diff --git a/ChangeLog b/ChangeLog
index 320f437..7526dd6 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,19 +1,24 @@
+Wed Jul 30 10:01:14 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/hmac_md5.h(added) src/tds/hmac_md5.c(added):
+	* src/tds/Makefile.am:
+	- added needed hmac code for NTLMv2
+
 Tue Jul 29 09:54:23 EDT 2008	JK Lowden <jklowden@freetds.org>
-	* src/ctlib/ct.c 
+	* src/ctlib/ct.c:
 	- patch from ML on 29 July 2008 from Andrew Victor 
 	- re BLOBs as parameters
 
 Mon Jul 28 16:56:36 EDT 2008	JK Lowden <jklowden@freetds.org>
-	* samples/odbc_rpc.pl src/odbc/error.c src/odbc/odbc.c
+	* samples/odbc_rpc.pl src/odbc/error.c src/odbc/odbc.c:
 	- tracking down SQLParamData behavior 
 
 Thu Jul 24 18:02:52 EDT 2008	JK Lowden <jklowden@freetds.org>
-	* samples/odbc_rpc.pl
-	* src/odbc/odbc.c src/odbc/prepare_query.c src/tds/net.c
+	* samples/odbc_rpc.pl:
+	* src/odbc/odbc.c src/odbc/prepare_query.c src/tds/net.c:
 	- test parameter binding with SQL_LONGVARCHAR
 
 Wed Jul 23 16:05:41 EDT 2008	JK Lowden <jklowden@freetds.org>
-	* src/odbc/error.c src/odbc/odbc.c
+	* src/odbc/error.c src/odbc/odbc.c:
 	- record error in log and remove some redundant logging of
 	- entry into static functions
 
@@ -483,4 +488,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2568 2008/07/29 14:07:09 jklowden Exp $
+$Id: ChangeLog,v 1.2569 2008/07/30 08:02:53 freddy77 Exp $
diff --git a/include/hmac_md5.h b/include/hmac_md5.h
new file mode 100644
index 0000000..e06c778
--- /dev/null
+++ b/include/hmac_md5.h
@@ -0,0 +1,29 @@
+/* FreeTDS - Library of routines accessing Sybase and Microsoft databases
+ * Copyright (C) 2008 Frediano Ziglio
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public
+ * License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+ */
+
+#ifndef _hmac_md5_h_
+#define _hmac_md5_h_
+
+/* $Id: hmac_md5.h,v 1.1 2008/07/30 08:02:54 freddy77 Exp $ */
+
+void hmac_md5(const unsigned char key[16],
+              const unsigned char* data, size_t data_len,
+              unsigned char* digest);
+
+#endif
diff --git a/src/tds/Makefile.am b/src/tds/Makefile.am
index f609bb6..be636b9 100644
--- a/src/tds/Makefile.am
+++ b/src/tds/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.63 2007/10/30 15:51:06 freddy77 Exp $
+# $Id: Makefile.am,v 1.64 2008/07/30 08:02:55 freddy77 Exp $
 
 SUBDIRS			=	unittests
 AM_CPPFLAGS		=	-I$(top_srcdir)/include
@@ -9,7 +9,7 @@ libtds_la_SOURCES=	mem.c token.c util.c login.c read.c \
 	locale.c challenge.c threadsafe.c vstrbuild.c md4.c md5.c \
 	des.c tdsstring.c getmac.c data.c net.c \
 	tds_checks.c tds_checks.h enum_cap.h log.c \
-	gssapi.c
+	gssapi.c hmac_md5.c
 libtds_la_LDFLAGS=
 libtds_la_LIBADD=
 
diff --git a/src/tds/hmac_md5.c b/src/tds/hmac_md5.c
new file mode 100644
index 0000000..f6e86e5
--- /dev/null
+++ b/src/tds/hmac_md5.c
@@ -0,0 +1,64 @@
+/* FreeTDS - Library of routines accessing Sybase and Microsoft databases
+ * Copyright (C) 2008  Frediano Ziglio
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public
+ * License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+ */
+
+/* $Id: hmac_md5.c,v 1.1 2008/07/30 08:02:55 freddy77 Exp $ */
+
+#include "tds.h"
+#include "md5.h"
+#include "hmac_md5.h"
+#include <memory.h>
+
+/**
+ * Calculates the HMAC-MD5 hash of the given data using the specified
+ * hashing key.
+ *
+ * @param key      The hashing key.
+ * @param data     The data for which the hash will be calculated. 
+ * @param data_len data length. 
+ * @param digest   The HMAC-MD5 hash of the given data.
+ */
+void hmac_md5(const unsigned char key[16],
+              const unsigned char* data, size_t data_len,
+              unsigned char* digest)
+{
+	int i;
+	MD5_CTX ctx;
+	unsigned char k_ipad[64];
+	unsigned char k_opad[64];
+
+	/* compute ipad and opad */
+	memset(k_ipad, 0x36, sizeof(k_ipad));
+	memset(k_opad, 0x5c, sizeof(k_opad));
+	for (i=0; i<16; ++i) {
+		k_ipad[i] ^= key[i];
+		k_opad[i] ^= key[i];
+	}
+
+	MD5Init(&ctx);
+	MD5Update(&ctx, k_ipad, 64);
+	if (data_len != 0)
+		MD5Update(&ctx, data, data_len);
+	MD5Final(&ctx, digest);
+
+	MD5Init(&ctx);
+	MD5Update(&ctx, k_opad, 64);
+	MD5Update(&ctx, digest, 16);
+	MD5Final(&ctx, digest);
+}
+

